/**
 * Changes all input code $name variablenames to {rownumber} representation and returns changed code (string)
 * @method varJSPtoNumJSP
 * @param {String} c - JSP code in $-form
 * @return {String} c - JAva Sketchpad code in {row no}-form
 */
function varJSPtoNumJSP(c) {
  var dList = [], dStr="", dVar="", indx1, indx2, j, dTmp="", commends=[], tmp="", tmp2="", tmp3="", tmp4="", bcmem, add=0 , bug_stopper = 0;
   

  
  //check for commends and "extra" lines
  while (c.indexOf('${')>=0 && bug_stopper <= 5000) {
    //removing $jsp comments - update on 04.04.2018
    c = c.slice(0, c.indexOf('${')) + c.slice(c.indexOf('$}')+2);
    bug_stopper++;
    if (bug_stopper >= 5000) {alert ("Error 1. Error in converting $JSP comments!"); return "null";}
  } //tmp = ""; 

  if (bug_stopper != 0) {bug_stopper = 0;}

  //check for macros and rename all $-chars
  while (c.indexOf('$(')>=0 && bug_stopper <= 5000) {
    tmp = tmp2 = c.slice(c.indexOf('$('), c.indexOf('$)')+2);
    //while (tmp2.indexOf('$')>=0)
      //tmp2 = tmp2.replace('$', '#');
    tmp2 = tmp2.replace(/\$/gi, '£');
    c = c.replace(tmp, tmp2);
    bug_stopper++;
    if (bug_stopper >= 5000) {alert ("Error 1. Error in converting $JSP comments!"); return "null";}
  } 
  tmp = tmp2 = ""; 

  if (bug_stopper != 0) {bug_stopper = 0;}

  while (c.indexOf('#')>=0 && c.indexOf('#')<c.indexOf('$') && bug_stopper <= 5000) {
    commends.push(c.slice(c.indexOf('#'), c.indexOf('$')));

    tmp2 = commends.pop();
    if ((tmp2.indexOf('WIDTH')>=0 || tmp2.indexOf('Width')>=0 || tmp2.indexOf('width')>=0) && (tmp2.indexOf('HEIGHT')>=0) || tmp2.indexOf('Height')>=0 || tmp2.indexOf('height')>=0)
      tmp = tmp2;
    c = c.replace(tmp2, "");
    bug_stopper++;
    if (bug_stopper >= 5000) {alert ("Error 2. Error in converting $JSP code!"); return "null";}
  } c = tmp + c;
  tmp = tmp2 = "";

  if (bug_stopper != 0) {bug_stopper = 0;}

  var k = 1;
  j = c.indexOf('$');

  for(var i=j; i<c.length; i++) {
    if (c.charAt(i) == '$' && c.charAt(i+1)!='{' && c.charAt(i+1)!='}' && c.charAt(i+1)!='(' && c.charAt(i+1)!=')') {
      indx1 = bcmem = i;
      while (c.charAt(i)!=' ' && c.charAt(i)!=',' && c.charAt(i)!=')' && c.charAt(i)!='@' && c.charAt(i)!='(') i++;
      indx2 = i;
      
      dVar = c.slice(indx1,indx2);
      if (checkJSPitem('|'+dVar.slice(1)+'|') && !checkJSPitem('|' + getValueFromString(c,'','',indx2) + '|')) {
          document.getElementById('errormessages_prog').innerHTML = dVar + ' on line '+ lineCount('codearea', dVar) +' is not a valid variable name without object construction command!\n ';
          $('#codearea').linenumbers({col_width:'37px', digits:'3'}, lineCount('codearea', dVar)); 
          return 'null';
      }
      dVar = dVar + '|';

      if (dStr.indexOf(dVar)==-1 && dVar != '$1|') {
        dStr = dStr + dVar;
        dList.push([dVar,k++]);
      }
      if (c.indexOf(';',i) >= 0 ) 
        i = c.indexOf(';',i);
      else {
        document.getElementById('errormessages_prog').innerHTML = 'There is a semicolon (;) missing on line <font color="#F00">' + c.slice(indx1, indx1+60) + '</font>';
        return 'null';
      }

    } //end of if

    //if dot command 3.5.2018
    else if (c.charAt(i) == '{' && c.charAt(i+1) == ',') {
      i = bracketClosure(c, '{', i+1)-1; 
    }


    /* update on 16.3.2018: User can input commands without variable name. Creates temporary variable name for each of these lines. */
    else if (c.charAt(i) != ' ' && c.charAt(i) != '{' && c.charAt(i) != ';' && c.charAt(i) != '$' && c.charAt(i) != '<' && isAlphabet(c.charAt(i))) {
      
      indx = i;
      while (c.charAt(i) != ';' && c.charAt(i) != '}' && c.charAt(i) != '>') i++;
      indx2=i+1;

      if (c.charAt(i) == ';') {        
        tmp3 = (c.slice(indx,i));
        //alert(tmp3);

        try {
          //if (checkJSPitem(tmp3.slice(0, tmp3.indexOf('(')).trim()) && tmp3.indexOf(';')<0) {
          if (checkJSPitem(getJSPCmndFromString(tmp3, 0)) && tmp3.indexOf(';')<0) {
            //if (c.slice(indx,indx2+1).indexOf('$') >= 0 && (c.slice(indx,indx2+1).indexOf('$') < c.slice(indx,indx2+1).indexOf(';'))) {
              //document.getElementById('errormessages_prog').innerHTML = "Found error in code. <br>Look for the line:<br><br>" + c.slice(indx,indx2+1) + "<br><br>and fix it! May be unknown command, error in syntax or missing ';'. <br><br>Convertion was stopped.";
              //c= c.slice(0, indx); i=0;
              //return "null";
            //}

            //alert(tmp3.slice(0, tmp3.indexOf('(')));
            //if (c.indexOf(tmp3, indx2) < 0) {
              tmp4 = '$var_wthout_name_'+add+' '+tmp3;
              //c = c.replace(tmp3, tmp4);
              c = c.slice(0,indx) + tmp4 + ";" + c.slice(indx2);
              //alert(c);
              add++;
              i = bcmem-1;
            //}
            //else {
              //document.getElementById('errormessages_prog').innerHTML = "Found error in code. <br>Look for the line:<br><br>" + c.slice(indx,indx2+1) + "<br><br>and fix it! There is duplicate of this line in code.";
              //c= c.slice(0, indx); i=0;
              //return "null";              
            //}
            

            bug_stopper++;
            if (bug_stopper > 10000) {
              alert("ERROR! \n(" + tmp3 +")\nThis caused problems! ");
              return null;
            }

            //if (c[i] == ';') alert(c[i] + c[i+1] + c[i+2]);
          } 

          else {
            //alert("Found error in code. \nLook for the line:\n\n" + tmp3 + "\n\nand fix it! \n\nConvertion was done to the point where error occurred.");
            //alert(tmp3);
            document.getElementById('errormessages_prog').innerHTML = "Error 7. Found error in code. <br>Look for the line:<br><br>"+ getJSPCmndFromString(tmp3,0) + "<br>" + c.slice(indx,indx2+1) + "<br><br>and fix it! May be unknown command, error in syntax or missing ';'. <br><br>Convertion was stopped.";
            //return "{1} FixedText(50,10,'ERROR IN CODE!')[];";
            //alert(c.slice(0, bcmem));
            //return c.slice(0, bcmem);
            c= c.slice(0, indx); i=0;
            return "null";
          } 
        } catch(e) {document.getElementById('ERRORS').innerHTML = e.message;}
      }
       

    } 
    /*end of update */
    //alert(c);
  } //end of for loop


  dList.sort(function(a,b) {
    return b[0].length - a[0].length;
  }); 
  //alert(dList);

  for(var i=0; i<dList.length; i++) {
    dList[i][0] = dList[i][0].replace('|', '');
    bug_stopper++;
    if (bug_stopper>=10000) {document.getElementById('errormessages_prog').innerHTML = "Error 3. Error in $JSP convertion."; return "null";}
  }

  if (bug_stopper != 10000) {bug_stopper = 0}

  while (c.indexOf('$1')>=0) {
    c = c.replace('$1', '#-1#');
  }
  while (c.indexOf('$2')>=0) {
    c = c.replace('$2', '#-2#');
  }
  while (c.indexOf('$3')>=0) {
    c = c.replace('$3', '#-3#');
  } 
  while (c.indexOf('$4')>=0) {
    c = c.replace('$4', '#-4#');
  } 

  //update 7.9.2018 replace variables in ,locus{  }
  var locus_indexses = [];
  var locuses = [];
  var old_locuses = [];
  //var new_locuses = [];
  var ex_in = 0;
  while (c.indexOf(',locus', ex_in)>0) {
    locus_indexses.push(c.indexOf(',locus',ex_in));
    locuses.push(c.slice(c.indexOf(',locus',ex_in), bracketClosure(c, '{', c.indexOf(',locus',ex_in))));
    ex_in = c.indexOf(',locus',ex_in)+6;
  }
  //update 7.9.2018 
  if (locuses.length>0) {
    
      for (var j=0; j<locuses.length; j++) {
        old_locuses[j] = locuses[j];
        for(var k=0; k<dList.length; k++) {
          while (locuses[j].indexOf(dList[k][0])>=0) locuses[j] = locuses[j].replace(dList[k][0], "{"+dList[k][1]+"}");
        }
        c = c.replace(old_locuses[j], locuses[j]);
      }
  }


  for(var i=0; i<dList.length; i++) {
    j=i+1;
    c = c.replace(dList[i][0], "{"+dList[i][1]+"}");

    while(c.indexOf(dList[i][0])>=0 && (c[c.indexOf(dList[i][0])+dList[i][0].length] == ' ' || c[c.indexOf(dList[i][0])+dList[i][0].length] == ',' || c[c.indexOf(dList[i][0])+dList[i][0].length] == ')' || c[c.indexOf(dList[i][0])+dList[i][0].length] == '@')) {
      c = c.replace(dList[i][0], dList[i][1]);
      bug_stopper++;
      if (bug_stopper>=10000) {document.getElementById('errormessages_prog').innerHTML = "Error 4. Error in replacing $JSP variables to {rows}."; return "null";}
    }

  }

  if (bug_stopper != 10000) {bug_stopper = 0}

  while (c.indexOf('$')>=0) {
    for (var i=0; i<dList.length; i++) {
      j=i+1;
      while(c.indexOf(dList[i][0])>=0 && (c[c.indexOf(dList[i][0])+dList[i][0].length] == ' ' || c[c.indexOf(dList[i][0])+dList[i][0].length] == ',' || c[c.indexOf(dList[i][0])+dList[i][0].length] == ')'))
        c = c.replace(dList[i], j);
    }
    while (c.indexOf('${')>=0)
      c = c.replace('${', '{');
    while (c.indexOf('$}')>=0)
      c = c.replace('$}', '}');

    bug_stopper++;
    if (bug_stopper>=10000) {document.getElementById('errormessages_prog').innerHTML = "Error 5. Error in replacing $JSP variables to {rows}.<br>Check that there is no undefined variables in your $JSP code and variables without name are not referred to.<br><br>Maybe this is the cause of error :<br> "+c.slice(c.indexOf('$'), c.indexOf(',',c.indexOf('$'))) +"<br><br> Check also that there are no missing semicolons (;) on command lines, possibly before command line :<br> " + c.slice(c.indexOf('$'), c.indexOf(',',c.indexOf('$'))) + "..."; return "null";}
  }
  
  //alert(c);

  return c;
}