/**
 * Check if param p is valid JSP constructor or not. Return true in case p is JSP constructor, else false
 * @method checkJSPitem
 * @param {String} p - string value JSP constructor
 * @return {boolen} true if p is JSP type constructor, else false
 */ 
function checkJSPitem(p) {
  var jsp = /*points*/          "|Point|FixedPoint|Midpoint|Point on object|Intersect|Intersect1|Intersect2|PlotXY|UnitPoint|DriverPoint|"+
            /*straight lines*/  "|Segment|Ray|Line|Perpendicular|Parallel|AxisX|AxisY|Polygon|Circle interior|Circle|Circle by radius|"+
            /*transformations*/ "|Reflection|Dilation|Dilation/SegmentRatio|Dilation/3PtRatio|Dilation/MarkedRatio|Rotation|Rotation/MarkedAngle|"+
                                "|Translation|VectorTranslation|Translation/FixedAngle/MarkedDistance|PolarTranslation|"+
                                "|Translation/MarkedAngle/FixedDistance|Translation/MarkedAngle/MarkedDistance|"+
            /*image*/           "|Image|"+
            /*measurements*/    "|Length|Angle|Perimeter|Circumference|Radius|Area|Slope|Distance|Ratio/Segments|Ratio/Points|Calculate|Parameter|"+
            /*text & buttons*/  "|FixedText|ShowButton|HideButton|MoveButton|AnimateButton|SimultaneousButton|"+
            /*coord system */   "|Coordinates|Origin&Unit|UnitCircle|"+
            /*locus*/           "|Locus|";
  if (jsp.indexOf(p)<0) return false;
  else return true;
}

/**
  * To check code for simple errors which are length, brackets etc.
  * @method codeDummyTest
  * @param {String} code - 
  * @return {Boolean} valid - true if code passes dummy-test, else false
  */
function codeDummyTest(code) {
  var valid = true;
  if (code.length == 0) return true;
  if (code.indexOf('(')<0 || code.indexOf(')')<0) valid = false;
  else if (code.indexOf('[')<0 || code.indexOf(']')<0) valid = false;
  else if (code.indexOf(';')<0) valid = false;
  else if (code.length>0 && code.length<10) valid = false;
  else if (code.indexOf(' {0} ')>-1) valid = false;
  return valid;
}