/**
 * Divides one big string file (original Java Sketchpad code) into array of separate rows and returns rows (Array).
 * @method separateCommands
 * @param {String} a - Java Sketchpad code -string
 * @return {Array<String>} rows - separated rows from Java Sketchpad code as an array
 **/ 
function separateCommands(a, is_macro) {
  var rows = [], 
  indx = 0, 
  i = 0, 
  numbers = "1234567890", 
  br_numb = "1}2}3}4}5}6}7}8}9}0}", 
  sr_numb = "{1{2{3{4{5{6{7{8{9",
  comment="", 
  tmp = "", 
  tmp2 = "",
  macro = "",
  wo_nr = [], 
  add = 0, 
  bug_stopper = 0;

  while (a.indexOf('<!--')>0 && a.indexOf('-->')>0) {

    a=a.slice(0, a.indexOf('<!--'))+a.slice(a.indexOf('-->')+3);
  }
  //let's put the index for i
  if (a.indexOf('£(') < a.indexOf('{'))
    i = a.indexOf('£(');
  else i = a.indexOf('{');

  if (is_macro) {
    rows.push(a.slice(0, a.indexOf(')')+1))    
    a = a.slice(a.indexOf(')')+1);
    i = indx = 0;
    while ( i < a.length) {
      if (a.charAt(i) == ';') {
        rows.push(a.slice(indx, i+1));
        i++;
        indx = i;
      }
      else i++;
    }  

  }
  
  
  while(i<a.length ) {

    if (a[i] == '{' && numbers.indexOf(a[i+1])>=0) {
      indx = a.indexOf(';', i);

      if (comment.length > 0) {
          rows.push(comment + a.slice(i, indx+1));
          comment = "";       
      } else {
        rows.push(a.slice(i, indx+1));
      }
      i = indx;

    }

    else if (a.charAt(i) == '£' && a.charAt(i+1) == '(') {
      macro = "MACRO:" + a.slice(i+2, a.indexOf('£)',i)) + ":MACRO ";
      i = a.indexOf('£)',i)+1;
      rows.push(macro);
    }

    else if (hasDotcommandInIndx(a,i,'{,LabelAl',9) || hasDotcommandInIndx(a,i,'{,label',7) || hasDotcommandInIndx(a,i,'{,text',6) || hasDotcommandInIndx(a,i,'{,dash',6) || hasDotcommandInIndx(a,i,'{,latex',7)) {  
      rows.push(a.slice(i+2, bracketClosure(a, '{', i+3)));
      if (rows[rows.length-2].indexOf('//comment')>=0) {
        tmp = rows[rows.length-2].slice(rows[rows.length-2].lastIndexOf('//')+2, rows[rows.length-2].lastIndexOf(';')+1); 
        rows[rows.length-2] = rows[rows.length-2].slice(0, rows[rows.length-2].lastIndexOf('//')+2) + "//comment:" + rows.pop() + "//" + tmp;
      }  
      else if (rows[rows.length-2].indexOf('/*comment')>=0){
        tmp = rows[rows.length-2].slice(rows[rows.length-2].lastIndexOf('*/')+2, rows[rows.length-2].lastIndexOf(';')+1); 
        rows[rows.length-2] = rows[rows.length-2].slice(0, rows[rows.length-2].lastIndexOf('*/')+2) + "//comment:" + rows.pop() + "//" + tmp;
      }   

      else 
        rows[rows.length-2] = rows[rows.length-2].slice(0, rows[rows.length-2].lastIndexOf(']')) + "//comment:" + rows.pop() + "//];"; 
      
      i = bracketClosure(a, '{', i+1)-1;
    }

    else if (hasDotcommandInIndx(a, i, '{,locus', 7) || hasDotcommandInIndx(a, i, '{,jxg', 5) || hasDotcommandInIndx(a, i, '{,setAtt', 8)) {  
      indx = i+2;
      
      tmp2 = a.slice(i+1, bracketClosure(a, '{', i+1)-1);

      rows.push(tmp2);

      if (rows[rows.length-2].indexOf('//comment')>=0) {
        tmp = rows[rows.length-2].slice(rows[rows.length-2].lastIndexOf('*/')+2, rows[rows.length-2].lastIndexOf(';')+1); 
        rows[rows.length-2] = rows[rows.length-2].slice(0, rows[rows.length-2].lastIndexOf('*/')+2) + "//comment:" + rows.pop() + "//" + tmp;
      } 
      else rows[rows.length-2] = rows[rows.length-2].slice(0, rows[rows.length-2].lastIndexOf(']')) + "//comment: " + rows.pop() + "//];";
  
      i = bracketClosure(a, '{', i+1);
    }

    else if (a[i] == '{' && a[i+1] == ',') { // useroption (e.g. arrowL or psize()) as commends in JSP code after command line
      rows.push(a.slice(i+2, bracketClosure(a, '{', i+3)-1));

      if (rows[rows.length-2].indexOf('//comment')>=0) {
        tmp = rows[rows.length-2].slice(rows[rows.length-2].lastIndexOf('*/')+2, rows[rows.length-2].lastIndexOf(';')+1); 
        rows[rows.length-2] = rows[rows.length-2].slice(0, rows[rows.length-2].lastIndexOf('*/')+2) + "//comment:" + rows.pop() + "//" + tmp;
      }
      else if (rows[rows.length-2].indexOf('/*comment')>=0){
        tmp = rows[rows.length-2].slice(rows[rows.length-2].lastIndexOf('*/')+2, rows[rows.length-2].lastIndexOf(';')+1); 
        rows[rows.length-2] = rows[rows.length-2].slice(0, rows[rows.length-2].lastIndexOf('*/')+2) + "//comment:" + rows.pop() + "//" + tmp;
        
      }      
      else 
        rows[rows.length-2] = rows[rows.length-2].slice(0, rows[rows.length-2].lastIndexOf(']')) + "//comment:" + rows.pop() + "//];"; 
      
      i = bracketClosure(a, '{', i+1)-1;
    }   

    else if (a[i] == '{' && numbers.indexOf(a[i+1])<0) {
      
      comment = comment + '/*comment:' + a.slice(i+1, bracketClosure(a, '{', i+1)-1) + '*/' ;

      i = bracketClosure(a, '{', i+1)-1;    

    } 

    i++;
  bug_stopper = bug_stopper +1;
  } //end of while 
  
  //add last comment possibly
  if (comment.length > 0) {
    //comment = comment.replace('comment', 'lastcomment');
    rows[rows.length-1] = rows[rows.length-1] + comment.slice(0, comment.indexOf('/*')+2) + 'lastComment' + comment.slice(comment.indexOf('comment')+7) ;
    //alert(rows[rows.length-1]);
    comment = "";
  }
  
  for (var i=0; i<rows.length; i++) {
    if (rows[i].indexOf('MACRO:')>=0) {
      rows[i] = rows[i] + rows[i+1];
      rows.splice(i+1, 1);
    }
  }

  //console.log(rows);
  return rows;
}