/** 
 *   Slices one row of JavaSketchpad code to javascript object that has following informtion:
 * - Row (row number in sketchpad code),
 * - Type (Type of sketchpad element as sketchpad constructor),
 * - JsxType (type as javascript understands element [in this algorithm]),
 * - Pos (includes info about position [x- and y-coordinates], possible name [buttons, texts, measurements] or/and objects [rows] that are referred to),
 * - Opts (sliced string from '[' to ']' in sketchpad code),
 * - Att (specific info included in Opts [sketchpad code sliced from '[' to ']'] as a jsxgraph attributes. This info includes following attributes: 
 *   Name, Color, Fixed, Visible, WithLabel, StrokeWidth, Straightlast, Straightfirst, AnchorX, Trace, Size, Infobox, LabelAlign
 * - Anim (has the info needed to create buttons [list of the objects (rows) referred to when creating a button],
 * @method sketchpadrowToJsxgElement
 * @param {String} a - One row of Java Sketchpad code
 * @return {Object} el - Object that has information separated from original Java Sketchpad element
 **/
function sketchpadrowToJsxgElement(a) {
  var el, 
    row, 
    type='', 
    jsxtype='', 
    ref='', 
    ctype='', 
    orig=a, 
    pos, 
    opts, 
    hlight,
    att, 
    visib=true, 
    anim=[], 
    tmpanim, 
    labalig="", 
    psize, 
    sinfo, 
    comment="", 
    jspcomment="", 
    labelalign, 
    arrowf=false, 
    arrowl=false, 
    snaptogrid="false",
    jxg_command = "",
    set_attr = "", 
    suf="",
    macro ="",
    input_macro = "";
    macro_add = 1, 
    fixed=false, 
    tmp="",
    orig_line="";
  var usercomments = ['arrowL','arrowF','psize','snapToGrid','text','latex','LabelAlign','labelAlign','showInfoBox','label','locus','setAttribute#','jxg#','attVisible','highlight','dash'], 
    extraattributes = "", 
    loc_to_rep=0, 
    rep_loc ="",
    first_jspcomment = -2,
    last_comment = "";

    //if last row is a comment


  a = a.trim();
  if (a.indexOf('];')<0) a = a.slice(0,a.length-1) + "[];";
  if (a.indexOf("font(")>0) {
    a = a.replace(a.slice(a.indexOf("font("), a.indexOf(")", a.indexOf("font("))+1), a.slice(a.indexOf("font(")+6, a.indexOf(")", a.indexOf("font("))-1));
  }
  /*if (a.indexOf('/*')>=0 && a.indexOf('*//*')>0) {
    el = {Row:0, Type:'commend', JsxType:'commend', isCommend:true};
    return el;
  }*/

  
  //macros 2.5.2018
  if (a.indexOf('MACRO:')>=0 && a.indexOf(':MACRO')>=0) {
    try {
      macro = a.slice(a.indexOf('MACRO:') + 6, a.indexOf(':MACRO'));
      a = a.slice(a.indexOf(':MACRO')+7);
      macro = separateCommands(macro, true);
      macro[0] = macro[0].trim();
      macro[0] = macro[0].slice(0, macro[0].length-1) + ",att)"; 
    } catch(e) {alert('Creating macro-list failed');}
    try {
      jsp_macros = jsp_macros + macro[0].slice(0, macro[0].indexOf('(')).trim();
    } catch(e) {alert('Error while adding macro name value to all_macros string')}
    
    for (var i in macro) {
      if (i>0) {
        macro[i] = "{" + i + "} " + macro[i];
        macro_add = macro_add+1;
      }

      macro[i] = macro[i].replace(/£1/gi, '#1');
      macro[i] = macro[i].replace(/£/gi, '');
      

      if (i>0) {
        macro[i] = sketchpadrowToJsxgElement(macro[i]);
        if (macro[i].Pos.indexOf('#1')>=0) {
          tmp = macro[0].slice(0,3)  + '_' + (macro[i].Row-1);
          macro[i].Pos = macro[i].Pos.replace(/#1/gi, tmp);
        }
        changeTypeToJSX(macro[i]);
        macro[i].Pos = getMacroPosValues(macro[i].Pos);
        changeAttributesToJSX(macro[i]);
        changeOptionsToJSX(macro[i]); 
      }
    } 
    
    //for (var i = 1; i<macro.length; i++) {
      //macro[0] = macro[0] + macro[i];
    //}
    //input_macro = macro[0];
    //alert(input_macro);
  }



  if (a.indexOf('/*comment:')>=0 ) {
    if (a.indexOf('lastComment')>=0) {
      comment = a.slice(a.indexOf('/*'), a.lastIndexOf('*/', a.indexOf('lastComment'))+2);
      //alert(comment);
    }
    else 
      comment = a.slice(a.indexOf('/*'), a.lastIndexOf('*/')+2);
    //if (comment.indexOf('lastComment')>= 0) {
      //comment = a.slice(a.indexOf('/*', a.indexOf('lastComment')), a.lastIndexOf('*/')+2);
      //alert(comment);
    //}
  }
  if (a.indexOf('//comment:')>=0 ) {
    jspcomment = a.slice(a.indexOf('//comment'), a.lastIndexOf('//')+2);
    //alert(jspcomment);
  }

  if (a.indexOf('lastComment')>=0) {
    //alert(a);
    last_comment = a.slice(a.indexOf('/*', a.indexOf('{')), a.lastIndexOf('*')+1) + "/";
    while(last_comment.indexOf('comment:')>=0)
      last_comment = last_comment.replace('comment:', '');
    a = a.slice(a.indexOf('{'), a.indexOf('/*', a.indexOf('{')));
    //alert(a);
  }
    // change JSPcomment useroptions to be written without comma, and set the original JSP comment in JSPComment property of an Object
//    for (var i=0; i<usercomments.length; i++) {
//      if (jspcomment.indexOf(usercomments[i])>=0) {
//        //if (first_jspcomment.length == -2) first_jspcomment = jspcomment.indexOf(usercomments[i]); 
//        try {
//          //if (jspcomment.length<1) jspcomment = jspcomment +","+ usercomments[i];
//          //else jspcomment =  jspcomment + "/*/," + usercomments[i] ;
//          
//          if (jspcomment.indexOf(',LabelAlign')>=0) {
//            jspcomment = ","+comment.slice(comment.indexOf('LabelAlign'), /*comment.lastIndexOf(')')+1*/ bracketClosure(comment, '(', 'LabelAlign'));
//            
//          }
//          if (jspcomment.indexOf(',locus#')>=0) {                      
//            jspcomment = jspcomment + comment.slice(comment.indexOf('('), comment.lastIndexOf('#')+1); ;      
//          }
//          if (jspcomment.indexOf(',label')>=0) {  
//            alert(jspcomment);                   
//           jspcomment = jspcomment + comment.slice(comment.indexOf('(', comment.indexOf('label')), /*comment.lastIndexOf(')')+1*/ bracketClosure(comment, '(', 'label')); ;      
//            
//          }
//          if (jspcomment.indexOf(',setAttribute#')>=0) { jspcomment = comment.slice(comment.indexOf('('), comment.lastIndexOf('#')+1); }
//          if (jspcomment.indexOf(',jxg#')>=0) { jspcomment = comment.slice(comment.indexOf('('), comment.lastIndexOf('#')+1); }
//        } catch(e) {alert(e )};
//      }
//    }


    if (jspcomment.length>0) {
      //jspcomment = comment.slice(first_jspcomment, comment.length);
      //comment = comment.slice(0,first_jspcomment); 
      
      a = a.replace(jspcomment, '');
      jspcomment = "{" + jspcomment + "}";
      while (jspcomment.indexOf('//comment:')>=0)
        jspcomment = jspcomment.replace('//comment:', ',');
      while(jspcomment.indexOf('//')>=0)
        jspcomment = jspcomment.replace('//', '}\n{');
      while(jspcomment.indexOf('{}')>=0)
        jspcomment = jspcomment.replace('{}', '');
      while(jspcomment.indexOf('}}')>=0)
        jspcomment = jspcomment.replace('}}', '}');
      if (jspcomment.indexOf('lastComment')>=0)
        jspcomment = jspcomment.slice(0, bracketClosure(jspcomment, '{'));
    }
    if (comment.length>0) {
      while (comment.indexOf('comment:')>=0) {
        comment = comment.replace('comment:', '');
      }
      while (comment.indexOf('*//*')>=0) {
        comment = comment.replace('*//*', '}\n{');
      }
      //alert(a);
      comment = comment.replace('*/', '*/\n')
      if (last_comment.length<1)
        a = a.slice(a.lastIndexOf('*/')+2, a.length-1);
      //alert(a);

      //alert(comment);
    }
    if (last_comment.length>0) {
      while (last_comment.indexOf('lastComment:')>=0) {
        last_comment = last_comment.replace('lastComment:', '');
      }
      while (last_comment.indexOf('*//*')>=0) {
        last_comment = last_comment.replace('*//*', '}\n{');
      }
      last_comment = last_comment.replace('*/', '*/\n')
      //a = a.slice(a.lastIndexOf('*/')+2, a.length-1);
      //alert(a);
      //alert(last_comment);
    }
  

  try {row = eval(a.slice(a.indexOf("{")+1, a.indexOf("}"))); } catch(e) {alert(e.message)}
  type = a.slice(a.indexOf("}")+1, a.indexOf("(")).trim(); 
  if (a.indexOf(")[")>=0 && a.indexOf(")['")<0 && a.indexOf(") ['") && a.indexOf(")[ '") && a.indexOf(") [ '"))
    pos = a.slice(a.indexOf("(")+1, a.indexOf(")[")).trim();
  else pos = a.slice(a.indexOf("(")+1, a.lastIndexOf(")", a.lastIndexOf("[")-1)).trim();
  
  ref = pos;

  opts = a.slice(a.indexOf("["), a.indexOf("]")+1).trim();

  if (type=="Calculate" || type=="Ratio/Points") {
    if (a.indexOf("layer(")>=0)
      a = a.replace(a.slice(a.indexOf("layer("), a.indexOf(")", a.indexOf("layer("))+1), "");
    if (a.indexOf("color(")>=0) {
      tmp = a.slice(a.indexOf("color("), a.indexOf(")", a.indexOf("color("))+1);
      a = a.replace(tmp, "colorvaluehere"); //change 'color(...)' to 'colorvaluehere'
    }
    if (a.indexOf("suffix")>0)
      pos = a.slice(a.indexOf("(")+1, a.lastIndexOf(")", a.indexOf("suffix")-1)+1).trim();
    else pos = a.slice(a.indexOf("(")+1, a.lastIndexOf(")")+1).trim();
    if (a.indexOf("colorvaluehere")>=0)
      a = a.replace("colorvaluehere",tmp); //change 'colorvaluehere' back to 'color(...)'
  }
  else if (type=="MoveButton" || type=="ShowButton" || type=="HideButton" || type=="SimultaneousButton") {
    //anim = eval("["+a.slice(a.indexOf('(', a.indexOf('(') + 1)+1, a.indexOf(')', a.indexOf(')') + 1))+"]");
    if (opts.indexOf("color(")==-1 && opts.indexOf("layer(")==-1)
      anim = eval("["+a.slice(a.lastIndexOf('(')+1, a.lastIndexOf(')'))+"]");
    else anim = eval("["+a.slice(a.lastIndexOf('(', a.lastIndexOf('['))+1, a.lastIndexOf(')', a.lastIndexOf('[')))+"]");
  }
  else if (type=="AnimateButton") {
    if (a.lastIndexOf('[')>0)
      tmpanim = a.slice(a.indexOf(")", a.lastIndexOf("'"))+1,a.lastIndexOf(")", a.lastIndexOf('['))) + "]";
    else 
      tmpanim = a.slice(a.indexOf(")", a.lastIndexOf("'"))+1,a.lastIndexOf(")")) + "]";
    tmpanim = tmpanim.replace(/\(/g, "[");
    tmpanim = tmpanim.replace(/\)/g, "]");
    //animate [[object to animate, object on to animate], [animation speed], [], []]
    anim[0] = eval(tmpanim.slice(tmpanim.indexOf("["),tmpanim.indexOf("]")+1));
    anim[1] = eval(tmpanim.slice(tmpanim.indexOf("][")+1,tmpanim.indexOf("]",tmpanim.indexOf("][")+1)+1));
    anim[2] = eval(tmpanim.slice(tmpanim.indexOf("[",tmpanim.indexOf("][")+2), tmpanim.lastIndexOf("][")+1));
    anim[3] = eval(tmpanim.slice(tmpanim.lastIndexOf("][")+1,tmpanim.lastIndexOf("]")+1));
    for (var i=0; i<anim[0].length; i+=2) { //change to ms and other options, make extras zero
      anim[1][i] = anim[1][i]*1000; anim[1].splice(i+1,0,0);
      anim[2].splice(i+1,0,0);
      anim[3].splice(i+1,0,0);
    }
    //alert("anim[0]: "+anim[0] +", anim[1]:"+ anim[1] + ", anim[2]:"+ anim[2] + ", anim[3]:"+ anim[3]);
  }          
  
  //if JSP object type is measurement  set fixed true and ctype = 'measurements'
  if (type == 'Coordinates' || type == 'Length' || type == 'Angle' || type == 'Perimeter' || 
      type == 'Circumference' || type == 'Radius' || type == 'Area' || type == 'Slope' || 
      type == 'Distance' || type == 'Ratio/Segments' || type == 'Ratio/Points' || type == 'Calculate' || type == 'Parameter') {
    fixed = true;
    ctype = 'measurements'
  }
  if (type == 'ShowButton' || type == 'HideButton' || type == 'SimultaneousButton' || type == 'AnimateButton' || type == 'MoveButton') {
    fixed = true;
    ctype = 'buttons';
  }
  if (type == 'Point' || type == 'Point on object' || type == 'UnitPoint')
    ctype = 'points';
  
  // check extra-attributes here
  // POINT SIZE 
    psize = eval(document.getElementById('jsxpointsize').value);
    if (a.indexOf("psize(")>0) {
      psize = eval(a.slice(a.indexOf("psize(")+6, a.indexOf(")", a.indexOf("psize(")+6)));
    }
    if (jspcomment.indexOf("psize")>0) {
      //psize = eval(jspcomment.slice(jspcomment.indexOf("psize(")+6, jspcomment.indexOf(")", jspcomment.indexOf("psize(")+6)));
      psize = eval(jspcomment.slice(jspcomment.indexOf("(", jspcomment.indexOf('psize'))+1, bracketClosure(jspcomment, '(', 'psize')-1));
    }

    // SHOW INFOBOX 
    if (document.getElementById('jsxshowinfo').checked == true) sinfo = true;
    else sinfo = false;
    if (a.indexOf("showInfoBox")>0 || jspcomment.indexOf('showInfoBox') > 0)
      sinfo = true;




    // LABEL ALIGNMENT 
    labelalign = createLabelAlign(document.getElementById('jsxlabelalignment').value, 0);
    if (a.indexOf("LabelAlign(")>0) {
      labalig = a.slice(a.indexOf("LabelAlign(")+11, a.indexOf(")", a.indexOf("LabelAlign(")));
      labelalign = createLabelAlign(labalig,0);
    }
    if (jspcomment.indexOf("LabelAlign")>0) {
      //alert(jspcomment);
      labalig = jspcomment.slice(jspcomment.indexOf("(", jspcomment.indexOf('LabelAlign'))+1, bracketClosure(jspcomment, '(', 'LabelAlign')-1);
      
      labelalign = createLabelAlign(labalig,0);
    }
    if (jspcomment.indexOf("labelAlign")>0) {
      //alert(jspcomment);
      labalig = jspcomment.slice(jspcomment.indexOf("(", jspcomment.indexOf('labelAlign'))+1, bracketClosure(jspcomment, '(', 'labelAlign')-1);
      
      labelalign = createLabelAlign(labalig,0);
    }
    
    if (type == "VectorTranslation")
      labelalign = createLabelAlign(document.getElementById('jsxlabelalignment').value, eval(document.getElementById('vectortranslation_correction').value));
    if (labalig.length>0) {
      labelalign = "{offset:["+labalig+"]}"; }





    // ARROWS 
    if (a.indexOf("arrowF") > 0 || jspcomment.indexOf('arrowF')>0)
      arrowf = true;
    if (a.indexOf("arrowL")>0 || jspcomment.indexOf('arrowL')> 0)
      arrowl = true;

    //locusToFunction comment
    if (jspcomment.indexOf('locus') > 0) {
      //loc_to_rep = eval(jspcomment.slice(jspcomment.indexOf('(')+1, jspcomment.indexOf(',', jspcomment.indexOf('('))));
      loc_to_rep = row;
      rep_loc = jspcomment.slice(jspcomment.indexOf('(')+1, jspcomment.lastIndexOf(')'));
      //alert(loc_to_rep);
      //alert(rep_loc);
    }
    
    //update 4.4.2018 highlight
    if (jspcomment.indexOf('highlight')>=0 || document.getElementById('usehighlight').checked == true)
      hlight = true;
    else hlight = false;


    // SNAP TO 
    if (a.indexOf("snapToGrid")>0 || jspcomment.indexOf('snapToGrid')> 0)
      snaptogrid = true;

    // isvisible?
    if (a.indexOf('hidden')>0) visib= false; else visib = true;

  att= { Name:'', 
          Color:'black', 
          Fixed:fixed, 
          Visible:visib, 
          Withlabel:true, 
          Strokewidth:1, 
          Straightlast:true, 
          Straightfirst:true, 
          AnchorX:'middle', 
          Info:0, 
          Trace:false, 
          Size:psize, 
          Infobox:sinfo, 
          LabelAlign:labelalign, 
          Stop:false, 
          ArrowF:arrowf, 
          ArrowL:arrowl, 
          SnapToGrid:snaptogrid, 
          Highlight:hlight,
          Suffix:suf
        };

  el= { Row:row, 
        Type:type, 
        JsxType:jsxtype, 
        CType:ctype, 
        ParentType:'none', 
        Pos:pos, 
        Opts:opts, 
        Att:att, 
        Anim:anim,
        Macro: macro, 
        comment, 
        JSPComment:jspcomment,
        LastComment:last_comment, 
        Ref:ref, 
        isReferred:true, 
        Orig: orig, 
        Original_line: a,
        locusToReplace:loc_to_rep, 
        replaceLocus:rep_loc
      };

  return el;
}