//var jsp = /*points*/          "Point|FixedPoint|Midpoint|Point on object|Intersect|Intersect1|Intersect2|PlotXY|UnitPoint|DriverPoint|"+
//            /*straight lines*/  "Segment|Ray|Line|Perpendicular|Parallel|AxisX|AxisY|Polygon|Circle interior|Circle|Circle by radius|"+
//            /*transformations*/ "Reflection|Dilation|Dilation/SegmentRatio|Dilation/3PtRatio|Dilation/MarkedRatio|Rotation|Rotation/MarkedAngle|"+
//                                "Translation|VectorTranslation|Translation/FixedAngle/MarkedDistance|PolarTranslation|"+
//                                "Translation/MarkedAngle/FixedDistance|Translation/MarkedAngle/MarkedDistance|"+
//            /*image*/           "Image|"+
//            /*measurements*/    "Length|Angle|Perimeter|Circumference|Radius|Area|Slope|Distance|Ratio/Segments|Ratio/Points|Calculate|Parameter|"+
//            /*text & buttons*/  "FixedText|ShowButton|HideButton|MoveButton|AnimateButton|"+
//            /*coord system */   "Coordinates|Origin&Unit|UnitCircle|"+
//            /*locus*/           "Locus|";

function getMacroFunction(e,attributes) {
  //var attributes ="{}";
  if (!attributes)
    attributes = setAttributes(e, '');

  if (e.Type == 'Point' || e.Type == 'FixedPoint') {
    return "('point', ["+e.Pos[0]+","+e.Pos[1]+"], "+attributes+");";
  } 
  else if (e.Type == 'Midpoint') {
    return "('midpoint', ["+e.Pos[0]+"], "+attributes+");";
  }
  else if (e.Type == 'Point on object') {
    try { return "('glider', ["+e.Pos[0]+","+e.Pos[1]+"], "+attributes+");"; }
    catch(e) { alert('Error: Point on object can\'t be used in macro. '); return null; }
  }
  else if (e.Type == 'Segment') {
    return "('segment', ["+e.Pos[0]+","+e.Pos[1]+"], "+attributes+");";
  }
  else if (e.Type == 'Line' || e.Type == 'Perpendicular' || e.Type == 'Parallel') {
    return "('line', ["+e.Pos[0]+","+e.Pos[1]+"], "+attributes+");";
  }
  else if (e.Type == 'Polygon') {
    //return "('polygon', ["+e.Pos[0]+","+e.Pos[1]+"], "+attributes+");";
    alert('Error: Polygon can\'t be used in macro. Contact admin.'); return null;
  }
  else if (e.Type == 'Ray') {
    return "('line', ["+e.Pos[0]+","+e.Pos[1]+"], "+attributes+");";
  }
  else if (e.Type == 'Intersect' || e.Type == 'Intersect2' || e.Type == 'Intersect1') {
    return "('intersection', ["+e.Pos+", "+e.Att.Info+"], "+attributes+");";
  }
  else if (e.Type == 'Dilation/3PtRatio') {
    return "('point', [function(){return Math.sign(Math.cos(JXG.Math.Geometry.rad("+e.Pos[3]+", "+e.Pos[2]+", "+e.Pos[4]+"))) * ("+e.Pos[2]+".Dist("+e.Pos[4]+") / "+e.Pos[2]+".Dist("+e.Pos[3]+")) * ("+e.Pos[0]+".X() - "+e.Pos[1]+".X()) + "+e.Pos[1]+".X()},function() {return Math.sign(Math.cos(JXG.Math.Geometry.rad("+e.Pos[3]+", "+e.Pos[2]+", "+e.Pos[4]+"))) * ("+e.Pos[2]+".Dist("+e.Pos[4]+") / "+e.Pos[2]+".Dist("+e.Pos[3]+")) * ("+e.Pos[0]+".Y() - "+e.Pos[1]+".Y()) + "+e.Pos[1]+".Y()}], "+attributes+");";
  }
  else {
    alert('Macro failed! ');
    return null;
  }
}

function getMacroPosValues(e){
  var values = [], ind1 = 0, ind2 = 0;
  for (var i = 0; i<e.length; i++) {
    if (e[i] == ',') {
      values.push(e.slice(ind1, i));
      ind1 = i+1;
    }    
  }
  values.push(e.slice(ind1));
  return values;
}