
/**
* Changes some values in original Java Sketchpad code into form that JSXGraph can understand.
* @method changeOptionsToJSX
* @param {Object} a - object a is created from original code and has the values that will be changed
* @return {Object} a - return object a with changed values
*/
function changeOptionsToJSX(a) {

  //change brackets
    a.Opts = a.Opts.replace("[", "{");
    a.Opts = a.Opts.replace("]", "}");
    a.Opts = a.Opts.replace(a.Opts.slice(a.Opts.indexOf("layer"), a.Opts.indexOf("layer")+9), "");

  //change color
  a.Opts = a.Opts.replace("black", "color:'black'");
    a.Opts = a.Opts.replace("white", "color:'white'");
    a.Opts = a.Opts.replace("red", "color:'red'");
    a.Opts = a.Opts.replace("blue", "color:'blue'");
    a.Opts = a.Opts.replace("green", "color:'green'");
    a.Opts = a.Opts.replace("yellow", "color:'yellow'");
    a.Opts = a.Opts.replace("magenta", "color:'magenta'");
    a.Opts = a.Opts.replace("cyan", "color:'cyan'");
    
    // change name
    a.Opts = a.Opts.replace("label('", "name:'");
    a.Opts = a.Opts.replace("label ('", "name:'");
    a.Opts = a.Opts.replace("'),", "',");
    a.Opts = a.Opts.replace("')", "'");
    
    // text alignment
    a.Opts = a.Opts.replace("justifyLeft", "anchorX:'left'");
    a.Opts = a.Opts.replace("justifyCenter", "anchorX:'middle'");
    a.Opts = a.Opts.replace("justifyRight", "anchorX:'right'");
    
    //change other options
  a.Opts = a.Opts.replace("hidden", "visible:false");
    a.Opts = a.Opts.replace("thick", "strokeWidth=2");
    a.Opts = a.Opts.replace("bold,", "");
    a.Opts = a.Opts.replace("{plain,", "{");
    a.Opts = a.Opts.replace("font(", "");
    a.Opts = a.Opts.replace("'Helvetica',", "");
    a.Opts = a.Opts.replace(",,", ",");
    
    return a;
}

/**
* Changes some attributes from original Java Sketchpad code into form that JSXGraph can understand
* @method changeAttributesToJSX(string) 
* @param {Object} a - object a is created from original code and has the values that will be changed
* @return {Object} a - return object a with changed values
*/
function changeAttributesToJSX(a) {
  var tmpcolor = [], tmp="", ind=0;
  
  // name attribute
  if (a.Opts.indexOf("label")>=0 || (a.JSPComment.indexOf("label")>=0 && a.JSPComment.indexOf("label") != a.JSPComment.indexOf("labelAlign"))) {
    
    a=labelByUser(a); //attributes-handler
  }
  
  if (document.getElementById('latex').checked == true && a.Att.Name.length > 0) {
      tmp = a.Att.Name;
      //alert(tmp);
      a.Att.Name = '\\\\'+'"+"('+tmp+'\\\\'+'"+")';
      a.Att.Name = a.Att.Name.replace('\\\\"+"( \\\\"+")', '');
      a.Att.Name = a.Att.Name.replace('\\\\"+"(\\\\"+")', '');
      //alert(a.Att.Name);
  }
        
  // colour attribute
  if (a.Opts.indexOf("white")>=0)
    a.Att.Color = 'grey';
  else if (a.Opts.indexOf("black")>=0)
    a.Att.Color = 'black';
  else if (a.Opts.indexOf("red")>=0)
    a.Att.Color = 'red';
  else if (a.Opts.indexOf("blue")>=0)
    a.Att.Color = 'blue';
  else if (a.Opts.indexOf("green")>=0)
    a.Att.Color = 'green'
  else if (a.Opts.indexOf("yellow")>=0)
    a.Att.Color = 'yellow'
  else if (a.Opts.indexOf("magenta")>=0)
    a.Att.Color = 'magenta';
  else if (a.Opts.indexOf("cyan")>=0)
    a.Att.Color = 'cyan';
  else if (a.Opts.indexOf("color(")>=0) {
    tmpcolor = eval("[" + a.Opts.slice(a.Opts.indexOf("color(")+6, a.Opts.indexOf(")", a.Opts.indexOf("color(")+6)) + "]");
    a.Att.Color = "#"+ rgbToHex(tmpcolor[0],tmpcolor[1],tmpcolor[2]);
  }
  
  // visible attribute
  if (a.Opts.indexOf("hidden")>=0)
    a.Att.Visible = false;
  if (a.Opts.indexOf("traced")>=0)
    a.Att.Trace = true;
  
  // thickness attribute  
  if (a.Opts.indexOf("thick3")>=0 || a.Opts.indexOf("thick")>=0)
    a.Att.Strokewidth = 3;
  if (a.Opts.indexOf("thick6")>=0)
    a.Att.Strokewidth = 6;
  if (a.Opts.indexOf("thick5")>=0)
    a.Att.Strokewidth = 5;
  if (a.Opts.indexOf("thick4")>=0)
    a.Att.Strokewidth = 4;
  if (a.Opts.indexOf("thick2")>=0)
    a.Att.Strokewidth = 2;
  if (a.Opts.indexOf("thick") <0 )
    a.Att.Strokewidth = 1;
  
  if (a.Opts.indexOf("fixed:true") >= 0)
    a.Att.Fixed = true;
  else if (a.Opts.indexOf("fixed:false") >= 0)
    a.Att.Fixed = false;
  
  // text alignment attribute 
  if (a.Opts.indexOf("justifyLeft") >= 0)
    a.Att.AnchorX = 'left';
  else if (a.Opts.indexOf("justifyCenter") >= 0)
    a.Att.AnchorX = 'middle';
  else if (a.Opts.indexOf("justifyRight") >= 0)
    a.Att.AnchorX = 'right';

  //suffix
  if (a.Opts.indexOf("suffix") >= 0) {
    a.Att.Suffix = a.Opts.slice(a.Opts.indexOf("'",a.Opts.indexOf("suffix"))+1, a.Opts.indexOf("'",a.Opts.indexOf("'",a.Opts.indexOf("suffix"))+1));
  }
  
  if (a.Opts.indexOf("_BREAK") >=0)
    a.Att.Stop = true;

  return a;    
}

/**
 * Get options as a full string {options}, that has all the options that are needed in construction of this object. 
 * The purpose of this function is to shorten the converted code. 
 * This is also to make changing of defaul options easier (for example point color).
 * @method setAttributes
 * @param {Object} e - Object that has option values
 * @param {String} s - optional, extra option to add options string. This is for some special attributes. Function just adds s in the return string.
 * @return {String} options - String that has only the options needed, for example {name:'A', color:'red'}. There will be no options that values are default in JSXgraph syntax
 */
function setAttributes(e, s, own, n, type) {
  //straightLast:"+el[i].Att.Straightlast+", straightFirst:"+el[i].Att.Straightfirst+", lastArrow:"+el[i].Att.ArrowL+", firstArrow:"+el[i].Att.ArrowF+"} );";

  var options = "{";
  
  if (e.CType == 'points') {
    options = options + 'name:"'+e.Att.Name+'",';
    if (e.Att.Name.length > 0 /*&& e.Att.LabelAlign != '{offset:[0,10]}'*/) options = options  + "label:"+e.Att.LabelAlign+",";
    if (e.Att.Color.length > 0) options = options + "color:'"+e.Att.Color+"',";
    if (!e.Att.Visible) options = options + "visible:"+e.Att.Visible+",";
    if (e.Att.Fixed) options = options + "fixed:"+e.Att.Fixed+",";
    if (e.Att.Size != 2) options = options + "size:"+e.Att.Size+",";
    //if (e.Att.Trace == true) options = options + "trace:"+e.Att.Trace+", ";
    if (!e.Att.Infobox) options = options + "showInfoBox:"+e.Att.Infobox+",";
    //if (e.Att.LabelAlign.length > 0 && e.Att.Name.length > 0) options = options + "label:"+e.Att.LabelAlign+",";
    if (e.Att.SnapToGrid == true) options = options + "snapToGrid:"+e.Att.SnapToGrid+",";
  }
  else if (e.CType == 'straightlines' || e.CType == 'curves') {
    if (e.Att.Name.length > 0) options = options + "label:'"+e.Att.Name+"',";
    if (e.Att.Color.length > 0) options = options + "strokeColor:'"+e.Att.Color+"',";
    if (e.JsxType == 'ray') options = options + "straightFirst:false,";
    options = options + "strokeWidth:"+e.Att.Strokewidth+",";
    if (e.Att.ArrowL == true) options = options + "lastArrow:true,";
    if (e.Att.ArrowF == true) options = options + "firstArrow:true,";
    if (e.JSPComment.indexOf('dash')>=0) options = options + "dash:" + (e.JSPComment.slice(e.JSPComment.indexOf('(')+1, e.JSPComment.lastIndexOf(')'))) + ",";
    if (!e.Att.Visible) options = options + "visible:"+e.Att.Visible+",";
    
  }
  else if (e.CType == 'circles' || type == 'circles') {
    if (e.Att.Name.length > 0) options = options + "label:'"+e.Att.Name+"',";
    if (e.Att.Color.length > 0) options = options + "strokeColor:'"+e.Att.Color+"',";
    if (!e.Att.Visible) options = options + "visible:"+e.Att.Visible+",";
    if (e.Att.Trace == true) options = options + "trace:"+e.Att.Trace+", ";
    options = options + "strokeWidth:"+e.Att.Strokewidth+",";
    if (e.JSPComment.indexOf('dash')>=0) options = options + "dash:" + (e.JSPComment.slice(e.JSPComment.indexOf('(')+1, e.JSPComment.lastIndexOf(')'))) + ",";
  }
  else if (e.CType == 'interiors') {
    //{name:'"+el[i].Att.Name+"', fillColor:'"+el[i].Att.Color+"', withLines:false,visible:"+el[i].Att.Visible+", highlight:false, showInfoBox:"+el[i].Att.Infobox+", label:"+el[i].Att.LabelAlign+"}
    options = options + "fillColor:'"+e.Att.Color+"',withLines:false,";
    if (!e.Att.Visible) options = options + "visible:"+e.Att.Visible+",";
    if (e.Att.Name.length > 0) options = options + "label:'"+e.Att.Name+"',";
  }
  else if (e.CType == 'transformations') {
    options = options + 'name:"'+e.Att.Name+'",';
    if (e.Att.Name.length > 0 /*&& e.Att.LabelAlign != '{offset:[0,10]}'*/) options = options + "label:"+e.Att.LabelAlign+",";
    if (e.Att.Color.length > 0 && e.Att.Color != 'red') options = options + "color:'"+e.Att.Color+"',";
    if (!e.Att.Visible) options = options + "visible:"+e.Att.Visible+",";
    if (e.Att.Size != 2) options = options + "size:"+e.Att.Size+",";
    if (!e.Att.Infobox) options = options + "showInfoBox:"+e.Att.Infobox+",";
  }
  else if (e.CType == 'measurements') {
    if (e.Att.Color.length > 0 && e.Att.Color != 'black') options = options + "color:'"+e.Att.Color+"',";
    if (e.Att.Fixed) options = options + "fixed:true,";
  }
  else if (e.CType == 'buttons') {
    options = options + "fixed:true,";
    if (e.Att.Color.length > 0 && e.Att.Color != 'black') options = options + "color:'"+e.Att.Color+"',";
    if (e.JsxType=='text') options = options + "anchorX:'"+e.Att.AnchorX+"',";
  }
  else {
    options = options + "color:'"+e.Att.Color+"',";
  }


  //update 4.4.2018 highlight
  if (!e.Att.Highlight)
    options = options + "highlight:false,";

  if (s.length>0) options = options + s;

  if (options[options.length-1]==",")
    return options.slice(0,options.length-1) + "}";
  else 
    return options + "}";
}

/** 
 * Function that creates and returns (Array) position of the glider point.
 * Param variables are string and number(a,b).
 * @method gliderPoint
 * @param {Object} a - JSXGraph Object
 * @param {Double} b - this is to set the glider point
 * @param {Object} c - Object circle
 * @return {Array} - coordinates for moving glider to right position
 */
function gliderPoint(a,b,c) {
  
  var d, dx, dy, x=0,y=0, p1x, p2x, p1y, p2y;
  if (a.getType() == 'segment' || a.getType() == 'line' || a.getType() == 'axis') {  
    //alert(a.getType() +", ");
    p1x = a.point1.X();
    p2x = a.point2.X();  
    p1y = a.point1.Y();  
    p2y = a.point2.Y();

    dx = p2x - p1x;
    dy = p2y - p1y;
 
    /*x = p1x + (dx * b);
    y = p1y + (dy * b);
    */
    x = p1x + (b*dx);
    y = p1y + (b*dy);
    return [x,y];
  }      
  else if (a.getType() == 'parallel' || a.getType() == 'perpendicular') {
    x = a.point1.X()+b;
    y = a.point1.Y()+b;
    return [x,y];
  }
  else if (a.getType() == 'circle') {
    d = a.Radius();
    x = c.X() + d*Math.cos(b);
    y = c.Y() - d*Math.sin(b);
    return [x,y];
  }
} 