/**
 * Function to create string that contains funtion as a string for 'Calculate' operation.
 * E.g. input calculateFunction("A2+3*@sin_", [5]) will product a string "(Math.sin((3*(A+2))))", where A is replaced with value from row no 5 in Java Sketchpad code.
 * Inputs are string (a), array of element indexes (b) and measurements (calculations) in that indexes in array b are referring to.
 * Uses function mathCalc to create string.
 * @method calculateFunction(string, array, array)
 * @param {String} a - string that has the calculation, for example "A2+3*@sin_"
 * @param {Array<Int>} b - array of elements in calculate command that are used as variables. For example if command is Calculate(0,315,'f(x,y) = ','A2^ B2^ -')(53,54)[magenta], b will be [53,54]
 * @param {Array<String>} calc - has the calculations that jsptojsx convertor has created as strings. 
 * @return {String} ans - answer for the calculation
 */
function calculateFunction(a,b,calc, line) {

    var i, j=0, tmpstr="", obj = [], terms = [], ans="", vbstr="", indx=0, v_indx=0;    
    var abc = "ABCDEFGHIJ", operators = "+-*/^%!", functions = "sin_ cos_ tan_ abs_ sqrt ln__ rond trnc sgn_ asin acos atan log_"; 
    var alrt = false;

    a = a.slice(a.lastIndexOf("'", a.lastIndexOf("'")-1)+1, a.lastIndexOf("'"));
    
    //for checking purposes, insert @alrt at the end of the calcultion to alert the return function
    if (a.indexOf('@alrt')>0) {
      a = a.slice(0, a.indexOf('@alrt'));
      alrt = true;
    }

        
    //Gettin values for variables here
    while (a.indexOf("#")>=0){
      indx = a.indexOf("#");
      /*if (a[indx+1] == 'A') j=0;
      else if (a[indx+1] == 'B') j=1;
      else if (a[indx+1] == 'C') j=2;
      else if (a[indx+1] == 'D') j=3;*/
      if (a[indx+2] == '1') v_indx=0;
      else v_indx = 1;
      tmpstr = calc[b[getNumberOfCharForCalculate(a[indx+1])]][v_indx];
      tmpstr = tmpstr.replace("function(){return ","");
      tmpstr = tmpstr.replace(";}","");
      while (tmpstr.indexOf("Dist")>=0 || tmpstr.indexOf("JXG.")>=0 || tmpstr.indexOf("Geometry")>=0) {
        tmpstr = tmpstr.replace("Dist","dist"); //change Dist() because it has capital 'D'
        tmpstr = tmpstr.replace("JXG.","jxg."); //change capital JXG
        tmpstr = tmpstr.replace("Geometry","geometry"); //change capital Geometry
      }
      tmpstr = "|"+tmpstr+"|";
      vbstr = a.slice(indx, indx+3);
      while(a.indexOf(vbstr)>=0) 
              a = a.replace(vbstr, tmpstr);
      vbstr="";

    }
    
    for (i=0; i<abc.length; i++) {
      
      if (a.indexOf(abc[i])>=0 ) {          
          //tmpstr = calc[b[j]];
          tmpstr = calc[b[getNumberOfCharForCalculate(abc[i])]];
          tmpstr = tmpstr.replace("function(){return ","");
          tmpstr = tmpstr.replace(";}","");

          while (tmpstr.indexOf("Dist")>=0 || tmpstr.indexOf("JXG.")>=0 || tmpstr.indexOf("Geometry")>=0) {
            tmpstr = tmpstr.replace("Dist","dist"); //change Dist() because it has capital 'D'
            tmpstr = tmpstr.replace("JXG.","jxg."); //change capital JXG
            tmpstr = tmpstr.replace("Geometry","geometry"); //change capital Geometry
          }

          tmpstr = "|"+tmpstr+"|";   
          while(a.indexOf(abc[i])>=0 )
              a = a.replace(abc[i], " "+tmpstr+" "); 
          j++;

      }

    }
    
    while (a.indexOf("dist")>=0 || a.indexOf("jxg.")>=0 || a.indexOf("geometry")>=0) {
      a=a.replace("dist","Dist"); //change all lowletter 'dist' back to 'Dist'
      a=a.replace("jxg.","JXG."); //change capital JXG
      a=a.replace("geometry","Geometry"); //change capital Geometry

    }
    if (a.indexOf(',|')>=0 || a.indexOf('|,')>=0) { alert('Error in calculate command line '+ line +', check your commas and apostrophes.'); return null;}
    
    for (i=0; i<a.length; i++){
        if (a[i] == "@") {
          i++; 
          terms.push(a[i++]+a[i++]+a[i++]+a[i]);
        }
        else if (a[i] == "|") {
          terms.push(a.slice(i+1,a.indexOf("|",i+1)));
          i = a.indexOf("|",i+1);
        }
        else if (operators.indexOf(a[i]) >= 0) {
          terms.push(a[i]);
        }
        else if (a[i] != " ") {
          var string =""; j=i;
          while(a[j] != " " && a[j] != "@" && operators.indexOf(a[j]) == -1 && abc.indexOf(a[j]) == -1) {
              string = string+a[j];
              j++; 
          } 
          terms.push(string); i=j-1;          
        } 
    } 

    for (i=0; i<terms.length; i++) {
      if (functions.indexOf(terms[i].toString()) >= 0) {
        ans = mathCalc(terms[i], obj.pop());
        obj.push(ans);              
      }
      else if (operators.indexOf(terms[i].toString()) >=0) {
        ans = mathCalc(terms[i], obj.pop(), obj.pop());
        obj.push(ans); 
      }
      else {
        obj.push(terms[i]);
      }
    }
    if (obj.length>0)
      ans = obj.pop();
    if (alrt) alert (ans);
  return ans;
}

/** 
 * Creates one calculation with given operator and inputs. Second input is optional.
 * E.g. mathCalc("+", "1", "5") returns string "(1+5)" and
 * mathCalc("@sin_", "3.14") returns string "Math.sin(3.14)".
 * @method  mathCalc
 * @param {String} f - mathematical operation
 * @param {String} a - mathematical value or expression
 * @param {String} b - mathematical value or expression
 * @return {String} mathematical expression as a JavaScript string
*/
function mathCalc(f,a,b) {
  if (f == "+") {return "("+b+"+"+a+")";}
    else if (f == "-") {return "("+b+"-"+a+")";}
    else if (f == "*") {return "("+b+"*"+a+")";}
    else if (f == "/") {return "("+b+"/"+a+")";;}
    else if (f == "^") {return "Math.pow("+b+","+a+")";}
    else if (f == "%") {return "(-1*"+a+")";}
    else if (f == "!") {return "(-1*"+a+")";}
    else if (f == "sin_") {return "Math.sin("+a+")";}
    else if (f == "cos_") {return "Math.cos("+a+")";}
    else if (f == "tan_") {return "Math.tan("+a+")";}
    else if (f == "abs_") {return "Math.abs("+a+")";}
    else if (f == "sqrt") {return "Math.sqrt("+a+")";}
    else if (f == "ln__") {return "Math.log("+a+")";}
    else if (f == "rond") {if (Math.abs(Math.abs(a)-Math.abs(Math.floor(a))) < Math.abs(Math.abs(a)-Math.abs(Math.ceil(a)))) return Math.floor(a); else return Math.ceil(a);}
    else if (f == "trnc") {return "Math.floor("+a+")";} //ROND / / SGN_!
    else if (f == "sgn_") {return "Math.sign("+a+")";}
    else if (f == "asin") {return "Math.asin("+a+")";}
    else if (f == "acos") {return "Math.acos("+a+")";}
    else if (f == "atan") {return "Math.atan("+a+")";}
    else if (f == "log_") {return "Math.log10("+a+")";}
}

/**
 * Simple function to get number of char for the Calculate operation (get order of variable)
 * @method getNumberOfCharForClaculation
 * @param {String} a - alphabet from A to F
 * @return {Int} integer from 0 to 5
 */
function getNumberOfCharForCalculate(a) {
  if (a=='A') return 0;
  else if (a=='B') return 1;
  else if (a=='C') return 2;
  else if (a=='D') return 3;
  else if (a=='E') return 4;
  else if (a=='F') return 5;
  else if (a=='G') return 6;
  else if (a=='H') return 7;
  else if (a=='I') return 8;
  else if (a=='J') return 9;
  else return 0;
}