/*
 * Method to check if in long string file in given index has a specific word, checking char by char
 * This is for dotcommands checking, max dotcommand length is 10 chars!
 * str = long string file
 * ind = given index to start checking from
 * wrd = word to look for
 * len = max dotcommand length by user (optional, default 10 char)
 */
function hasDotcommandInIndx(str, ind, wrd, len) {
  
  var str_shrink = '';
  var max_len = ind + 10;
  
  if (len) max_len = ind + len;

  //create shorter string
  for (var i = ind; i<max_len; i++) {
    str_shrink += str.charAt(ind);
  }

  //check
  if (str_shrink.indexOf(wrd)>=0) return true;
  return false;
}

/*
 *
 * returns all variables that need to be replaced
 * 
 */
function replaceJspVariablesFromString(str) {
  var output = [];
  var tmp = "";
  var max_len = 3;

  for (var i=0; i<str.length; i++) {
    if (str.charAt(i) == '{') {
      i++;
      tmp = (str.slice(i, bracketClosure(str, '{', i)-1));
      if (tmp.length<=max_len && Number.isInteger(eval(tmp))) output.push(str.slice(i, bracketClosure(str, '{', i)-1));
    }
  }
  return output;  
}

/*
 * Return line count for some string to occur in given texarea (id value) 
 *
 *
 */
function lineCount(id, txt) {

	var str = document.getElementById(id).value;
	if (str.indexOf(txt)<0) return -1;

	return (str.slice(0, str.indexOf(txt)).match(/\n/g)||[]).length + 1;
	//return (str.slice(0, str.indexOf(txt)).match(/[^\n]*\n[^\n]*/gi)).length +1;
}

/**
 * Simple string cleaning function (trim and replace all ' with "), return changed s (String).
 * @method cleanString
 * @param {String} s - string
 * @return {String} s - "cleaned" string
 */
function cleanString(s) {
  s = s.trim();
  //s = s.replace(/"/g, "\'');
  return s;
}

/** 
 * Help function to change colour from RBG to Hex
 * source: http://www.javascripter.net/faq/rgbtohex.htm 
 * @method rgbToHex
 * @param {String} R -
 * @param {String} G -
 * @param {String} B -
 * @return {String} toHex(R)+toHex(G)+toHex(B) - calculated Hex-colour
 */
function rgbToHex(R,G,B) {return toHex(R)+toHex(G)+toHex(B)}

/**
 * Help function to change colour from RBG to Hex
 * source: http://www.javascripter.net/faq/rgbtohex.htm 
 * @method toHex
 * @param {String} n - value to be changed
 * @return {String} changed Hex-value
 */
function toHex(n) {
  n = parseInt(n,10);
  if (isNaN(n)) return "00";
  n = Math.max(0,Math.min(n,255));
  return "0123456789ABCDEF".charAt((n-n%16)/16)
  + "0123456789ABCDEF".charAt(n%16);
} /* /source */

/**
 * Check if input (string) is jspcode with $variables
 * @method checkJSPStyle
 * @param {String} c - JSP code
 * @return {Boolean}
 */
function checkJSPStyle(c) {
  if (c.indexOf('$')>=0) //if there is $-char in code return false
    return false;
  return true;
}

/*
 * Check if char is alphabet
 * @method isAlpabet
 * @param {Char} c - char
 * @return {boolean} true if c is an alphabet else false
 */
function isAlphabet(c) {
  var alphabets = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
  if (alphabets.indexOf(c)>=0) return true;
  return false;
}

function contains(a, obj) {
  if (a.indexOf(obj) > -1) return true;
  return false;
}

  /**
 * returns  index of bracket closure from a string 
 s = given string
 b = bracket style (start bracket)
 t = index (number or indexOf(string))
*/
function bracketClosure(s, b, t) {
  var counter = 0;
  var bracket_style = '}';
  var i;

  if (b == '(') bracket_style = ')';
  else if (b == '[') bracket_style = ']';

  if (Number.isInteger(t)) {
    i=t;
    while (counter > -1) {
      if (s.charAt(i) == b) {counter = counter+1; i++}
      else if (s.charAt(i) == bracket_style) {counter= counter-1; i++}
      else i++;
      if (i==s.length-1) return i;
    }
  }
  else if (!Number.isInteger(t)) {
    i = s.indexOf(b,s.indexOf(t))+1 
    if (i<0) return s.length-1; 
    while (counter > -1) {
      if (s[i] == b) {counter=counter+1; i++}
      else if (s[i] == bracket_style) {counter=counter-1; i++}
      else i++;
      if (i==s.length-1) return i;
    }
  }
  else {alert('error'); return null;}
  
  return i;
}

  function getValueFromString(s, c, m, i) {
    var goodChars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890-_";
    var value = "";
    var ind = 0;
    if (i) ind = i;
    else if (m) ind = s.indexOf(m, s.indexOf(c));
    else ind = s.indexOf(c) + c.length; 
    

    while(s.charAt(ind) == ' ' || goodChars.indexOf(s.charAt(ind))<0) ind = ind+1;

    while(goodChars.indexOf(s.charAt(ind))>=0) {
      value = value + s[ind];
      ind=ind+1;
    }
    return value;
  }

  function changeTextApostrophes(text) {
  var t = text;
  var count = 0;
  var i1, i2;
  var strp = [];
  var tmp;
  var result = "";


  if (t.indexOf("'")<0)
    return t;
  else {

    

    strp.push(t.slice(0, t.indexOf("'")));
    var i = t.indexOf("'");
    /*for (var i=t.indexOf("'"); i<t.length; i++)*/ while (i < t.length) {
      
      if (t.charAt(i) == "'") {
        i1 = i;
        while (t.charAt(i) == "'" && i < t.length) {
          count = count + 1;
          i = i + 1;
        }
        
        i2 = i;
        tmp = t.slice(i1, i2);
        //alert(tmp);
        count = count / 2;
        //alert(t[i+1]);
        for (var j=0; j<count; j++)
          tmp = tmp.replace("''", "\'");
        //i = i2;
        count = 0;
        strp.push(tmp);
      }
      else {
        
        i1= i;
        while (t.charAt(i) != "'" && i < t.length)
          i = i + 1;

        i2 = i;
        tmp = t.slice(i1,i2);
        //alert(tmp);
        strp.push(tmp);
        //i = i2;
      }
      
    }
    for (var i = 0; i<strp.length; i++)
      result = result + strp[i];
    return result;
  }
}